import sys
import numpy as np
import cv2

n = len( sys.argv )
if n != 2 :
	print( "Args: nombre_imagen" )
	sys.exit(1)

nombre = sys.argv[1]

img1 = cv2.imread( nombre, cv2.IMREAD_GRAYSCALE )
print( img1.shape )

# cv2.imshow( "Imagen de entrada", img1 )
# cv2.waitKey(0)

# Vamos a procesar la imagen de entrada
# Este es el suavizado
img2 = cv2.GaussianBlur( img1, (7,7), 0 )
# cv2.imwrite( "suavizada.png", img2 )

# La binarizamos
ret, img3 = cv2.threshold( img2, 30, 255, cv2.THRESH_BINARY_INV )
cv2.imwrite( "binarizada.png", img3 )

# Separamos cada objeto dentro de la imagen binarizada
# En Structural Analysis and Shape Descriptors
# en la documentación de openCV
n, img4  = cv2.connectedComponents( img3, 8 )

print( n )
print( type(img4) )
print( img4.shape )

rows, cols = img4.shape
forma = np.zeros( img1.shape, np.uint8 )
i = 1
while i < n :
	# Copiar cada forma en una solo imagen
	# y guardarla
	j = 0
	while j<rows :
		k = 0
		while k<cols :
			if img4[j,k] == i :
				forma[j,k] = 255
			else :
				forma[j,k] = 0
			k +=1 
		j +=1 

	nombre_salida = str(i) + ".png"
	cv2.imwrite( nombre_salida, forma )
	# Calcular los momentos de Hu para cada forma
	mom = cv2.moments( forma )
	hu = cv2.HuMoments( mom )
	print( i, end=' ' )
	j = 0
	while j < 7:
		print( hu[j,0], end=" " )
		j += 1 
	print( )

	i += 1
	
